import { EventEmitter, Component, Input, Output, NgModule, Injectable, Injector, ComponentFactoryResolver, ApplicationRef, ɵɵdefineInjectable, ɵɵinject, INJECTOR, Pipe, ViewEncapsulation, ElementRef, Renderer2, Inject, ViewChild } from '@angular/core';
import { CommonModule, DOCUMENT } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { FormGroup, FormBuilder, ReactiveFormsModule } from '@angular/forms';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { MatFormFieldModule, MatInputModule, MatTooltipModule, MatIconModule, MatMenuModule, MatButtonModule } from '@angular/material';
import { AngularFontAwesomeModule } from 'angular-font-awesome';
import { trigger, state, style, transition, animate } from '@angular/animations';
import * as _moment from 'moment';
import { PerfectScrollbarComponent, PerfectScrollbarModule, PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Input con material
 */
class InputComponent {
    /**
     * Crearemos un formGroup por defecto en caso no se envie
     * @param {?} formBuilder
     */
    constructor(formBuilder) {
        this.formBuilder = formBuilder;
        /**
         * Apariencia de material del input
         */
        this.appearance = 'outline';
        /**
         * padre del input
         */
        this.parent = new FormGroup({});
        /**
         * padre del input
         */
        this.name = 'default';
        /**
         * tooltip a mostrar
         */
        this.tooltip = '';
        /**
         * position del tooltip
         */
        this.position = 'above';
        /**
         * texto abajo del input
         */
        this.hint = '';
        /**
         * label en el input
         */
        this.label = '';
        /**
         * Icono  en la parte final del textbox
         */
        this.iconMatSuffix = '';
        /**
         * texto en la parte final del textbox
         */
        this.spanMatSuffix = '';
        /**
         * Icono  en la parte inicial del textbox
         */
        this.iconMatPrefix = '';
        /**
         * texto en la parte inicial del textbox
         */
        this.spanMatPrefix = '';
        /**
         * evento keydown emita un evnto
         */
        this.keydown = new EventEmitter();
        /**
         * evento que retorna el valor del input
         */
        this.value = new EventEmitter();
        this.parent = this.formBuilder.group({
            default: ''
        });
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * Validacion de que los elementos no sean null undefined o vacios
     * @param {?} element
     * @return {?}
     */
    validationValue(element) {
        if (element !== undefined && element !== null && element !== '') {
            return true;
        }
        return false;
    }
    /**
     * Retornamos un nuevo evento y llamamos a la funcion emitValue
     * @param {?} event Evento al presionar una tecla
     * @return {?}
     */
    keydownFun(event) {
        this.keydown.emit(event);
        this.emitValue();
    }
    /**
     * Emitimos un evento retornando el valor actual del input
     * @return {?}
     */
    emitValue() {
        this.value.emit(this.parent.controls[this.name].value);
    }
}
InputComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-input',
                template: "<div [formGroup]=\"parent\" class=\"w-100\">\r\n  <mat-form-field class=\"w-100\" [appearance]=\"appearance\" [matTooltip]=\"tooltip\" [matTooltipPosition]=\"position\" >\r\n    <mat-label *ngIf=\"validationValue(label)\">{{label}}</mat-label>\r\n    <input matInput (keyup)=\"keydownFun($event)\" formControlName=\"{{name}}\" >\r\n    <em *ngIf=\"validationValue(iconMatPrefix)\" [ngClass]=\"iconMatPrefix\" matPrefix></em>\r\n    <span *ngIf=\"validationValue(spanMatPrefix)\" matPrefix>spanMatPrefix</span>\r\n    <em *ngIf=\"validationValue(iconMatSuffix)\" [ngClass]=\"iconMatSuffix\" matSuffix></em>\r\n    <span *ngIf=\"validationValue(spanMatSuffix)\" matSuffix>spanMatSuffix</span>\r\n    <mat-hint *ngIf=\"validationValue(hint)\">{{hint}}</mat-hint>\r\n  </mat-form-field>\r\n</div>\r\n",
                styles: ["::ng-deep .mat-form-field-flex>.mat-form-field-infix{padding:.6em 0!important}::ng-deep .mat-form-field-label-wrapper{top:-1.2em;color:rgba(0,0,0,.5)}::ng-deep .mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label{-webkit-transform:translateY(-1.3em) scale(.7);transform:translateY(-1.3em) scale(.7);width:133.33333%}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline{background-color:#fff;border-radius:.3rem}::ng-deep .mat-form-field-appearance-outline .mat-form-field-prefix,::ng-deep .mat-form-field-appearance-outline .mat-form-field-suffix{top:-.15em!important;padding:0 .8rem}"]
            }] }
];
/** @nocollapse */
InputComponent.ctorParameters = () => [
    { type: FormBuilder }
];
InputComponent.propDecorators = {
    appearance: [{ type: Input }],
    parent: [{ type: Input }],
    name: [{ type: Input }],
    tooltip: [{ type: Input }],
    position: [{ type: Input }],
    hint: [{ type: Input }],
    label: [{ type: Input }],
    iconMatSuffix: [{ type: Input }],
    spanMatSuffix: [{ type: Input }],
    iconMatPrefix: [{ type: Input }],
    spanMatPrefix: [{ type: Input }],
    keydown: [{ type: Output }],
    value: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Input con autocomplete definido
 */
class InputSearchComponent {
    /**
     * @ignore
     */
    constructor() { }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
}
InputSearchComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-input-search',
                template: "<p>\n  input-search works!\n</p>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
InputSearchComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxUtilitarioFormstModule {
}
NgxUtilitarioFormstModule.decorators = [
    { type: NgModule, args: [{
                declarations: [InputComponent, InputSearchComponent],
                imports: [
                    ReactiveFormsModule,
                    CommonModule,
                    MatFormFieldModule,
                    MatInputModule,
                    MatTooltipModule
                ],
                exports: [
                    InputComponent,
                    InputSearchComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Servicio que añade un componente en tiempo de ejecucion
 */
class DynamicComponentService {
    /**
     * @ignore
     * @param {?} injector
     * @param {?} resolver
     * @param {?} appRef
     */
    constructor(injector, resolver, appRef) {
        this.injector = injector;
        this.resolver = resolver;
        this.appRef = appRef;
    }
    /**
     * Servicio que permite injectar componente en tiempo de ejecucion
     * \@example
     * this.dynamicComponentService.injectComponent(PopupComponent,
     *        x => { x.tipo = currentFeature.properties.marcador ; x.id = currentFeature.properties.id; }  );
     * @template T
     * @param {?} component El componente a insertar
     * @param {?=} propertySetter Las propiedades del componente que va a recibir
     * @return {?}
     */
    injectComponent(component, propertySetter) {
        // Elimina el componente si este ya existe
        if (this.compRef) {
            this.compRef.destroy();
        }
        // Resuelve el componente y lo crea
        /** @type {?} */
        const compFactory = this.resolver.resolveComponentFactory(component);
        this.compRef = compFactory.create(this.injector);
        // Pasa las nuevas propiedades al componente
        if (propertySetter) {
            propertySetter(this.compRef.instance);
        }
        // Attach to Application
        this.appRef.attachView(this.compRef.hostView);
        // Creamos un div y añadimos el component
        /** @type {?} */
        const div = document.createElement('div');
        div.appendChild(this.compRef.location.nativeElement);
        // Retornamos al dom el nuevo div creado
        return div;
    }
}
DynamicComponentService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
DynamicComponentService.ctorParameters = () => [
    { type: Injector },
    { type: ComponentFactoryResolver },
    { type: ApplicationRef }
];
/** @nocollapse */ DynamicComponentService.ngInjectableDef = ɵɵdefineInjectable({ factory: function DynamicComponentService_Factory() { return new DynamicComponentService(ɵɵinject(INJECTOR), ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef)); }, token: DynamicComponentService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Modulo dynamic el cual contiene el servicio para añadir un componente en tiempo de ejecucion
 */
class NgxUtilitarioDynamicModule {
}
NgxUtilitarioDynamicModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                imports: [
                    CommonModule
                ],
                providers: [
                    DynamicComponentService
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente que nos permite repetir un icono n vces y activar los primeros iconos
 */
class RepeatIconComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Cantidad de veces a repetir el icono
         */
        this.repetir = 5;
        /**
         * Cantidad de iconos a activar
         */
        this.activo = 0;
        /**
         * Icono a mostrar utilizo font-awesome
         */
        this.icono = 'fa fa-user';
        /**
         * Color del icono normalmente por defecto es #000
         */
        this.color = '#000';
        /**
         * COlor del icono activo por defecto es #000
         */
        this.colorActivo = '#000';
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
}
RepeatIconComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-repeat-icon',
                template: "<ng-container class=\"repetirIcono\">\n  <em *ngFor=\"let item of activo | numberToArray\" class=\"{{icono}}\" [style.color]=\"colorActivo\"></em>\n  <em *ngFor=\"let item of (repetir - activo) | numberToArray\" class=\"{{icono}}\" [style.color]=\"color\"></em>\n</ng-container>",
                styles: [".repetirIcono{display:inline-flex}"]
            }] }
];
/** @nocollapse */
RepeatIconComponent.ctorParameters = () => [];
RepeatIconComponent.propDecorators = {
    repetir: [{ type: Input }],
    activo: [{ type: Input }],
    icono: [{ type: Input }],
    color: [{ type: Input }],
    colorActivo: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Inserta un span con clase search-highlight en la palabra resaltada
 * si desea cambiar este estilo utilizar "::ng-deep search-highlight"
 */
class HighlightPipe {
    /**
     * Añade un span entre el texto para añadirle efectos
     * @param {?} text Texto completo
     * @param {?} search Texto a buscar
     * @return {?}
     */
    transform(text, search) {
        if (search && text) {
            /** @type {?} */
            let pattern = search.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
            pattern = pattern.split(' ').filter((/**
             * @param {?} t
             * @return {?}
             */
            (t) => {
                return t.length > 0;
            })).join('|');
            /** @type {?} */
            const regex = new RegExp(pattern, 'gi');
            return text.replace(regex, (/**
             * @param {?} match
             * @return {?}
             */
            (match) => `<span class="search-highlight">${match}</span>`));
        }
        else {
            return text;
        }
    }
}
HighlightPipe.decorators = [
    { type: Pipe, args: [{
                name: 'highlight'
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Crea un arreglo de tamaño n
 */
class NumberToArrayPipe {
    /**
     * crea un arreglo de tamaño n
     *
     * \@example
     * *ngFor="let item of 2 | numberToArray"
     *
     * @param {?} length tamaño del nuevo arreglo
     *
     * @return {?} un arreglo de tamaño n
     */
    transform(length) {
        /** @type {?} */
        const res = [];
        for (let i = 0; i < length; i++) {
            res.push(i);
        }
        return res;
    }
}
NumberToArrayPipe.decorators = [
    { type: Pipe, args: [{
                name: 'numberToArray'
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxUtilitarioPipesModule {
}
NgxUtilitarioPipesModule.decorators = [
    { type: NgModule, args: [{
                declarations: [HighlightPipe, NumberToArrayPipe],
                imports: [
                    CommonModule
                ],
                exports: [
                    HighlightPipe,
                    NumberToArrayPipe
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Modulo en el cual se trabajara sobre iconos
 */
class NgxUtilitarioIconsModule {
}
NgxUtilitarioIconsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [RepeatIconComponent],
                imports: [
                    CommonModule,
                    NgxUtilitarioPipesModule
                ],
                exports: [RepeatIconComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Servicio que permite añadir modales
 */
class ModalService {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Modales registrados en el servicio
         */
        this.modals = [];
    }
    /**
     * Añadimos el modal a la lista de modales a mostrar
     * @param {?} modal Modal a mostrar
     * @return {?}
     */
    add(modal) {
        this.modals.push(modal);
    }
    /**
     * Eliminamos un modal de la lista de modales a mostrar
     * @param {?} id id del model que vamos a eliminar
     * @return {?}
     */
    remove(id) {
        this.modals = this.modals.filter((/**
         * @param {?} x
         * @return {?}
         */
        x => x.id !== id));
    }
    /**
     * Abrir un modal
     * @param {?} id id del modal que queremos mostrar
     * @return {?}
     */
    open(id) {
        /** @type {?} */
        const modal = this.modals.filter((/**
         * @param {?} x
         * @return {?}
         */
        x => x.id === id))[0];
        modal.open();
    }
    /**
     * Cerrar un modal
     * @param {?} id id del modal que queremos ocultar
     * @return {?}
     */
    close(id) {
        /** @type {?} */
        const modal = this.modals.filter((/**
         * @param {?} x
         * @return {?}
         */
        x => x.id === id))[0];
        modal.close();
    }
}
ModalService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ModalService.ctorParameters = () => [];
/** @nocollapse */ ModalService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ModalService_Factory() { return new ModalService(); }, token: ModalService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Abre el nuevo componente enuna ventana emergente con una animacion de oppocity
 */
class ModalComponent {
    /**
     * @ignore
     * @param {?} modalService
     * @param {?} el
     * @param {?} renderer
     * @param {?=} document
     */
    constructor(modalService, el, renderer, document) {
        this.modalService = modalService;
        this.el = el;
        this.renderer = renderer;
        /**
         * variable por la cual asignamos la animacion al modal
         */
        this.openclose = 'closed';
        this.document = (/** @type {?} */ (document));
        this.element = el.nativeElement;
    }
    /**
     * Al inicializar el componente validamos si tiene un id, lo añadimos al html, y le asignamos una accion de cerrar
     * @return {?}
     */
    ngOnInit() {
        /** @type {?} */
        const modal = this;
        // Validamos si tiene el atributo id
        if (!this.id) {
            console.error('modal must have an id');
            return;
        }
        // añadimos el modal despues </body>) para que se pueda mostrar sobre todos los elementos
        this.document.body.appendChild(this.element);
        // cerrar modal
        this.element.addEventListener('click', (/**
         * @param {?} e
         * @return {?}
         */
        (e) => {
            if (e.target.className === 'ngx-utilitario-modal') {
                modal.close();
            }
        }));
        // add self (this modal instance) to the modal service so it's accessible from controllers
        this.modalService.add(this);
        this.close();
    }
    /**
     * Se elimina del modal service cuando el componente es destruido
     * @return {?}
     */
    ngOnDestroy() {
        this.modalService.remove(this.id);
        this.element.remove();
    }
    /**
     * abrimos el modal
     * Cambiamos la variable de la animacion
     * le aplicamos el estilo display block y le asignamos la
     * clase ngx-utilitario-modal-open que permite visualizar el componente
     * @return {?}
     */
    open() {
        this.openclose = 'open';
        this.element.style.display = 'block';
        this.renderer.addClass(this.document.body, 'ngx-utilitario-modal-open');
        // this.renderer.setStyle(document.body, 'overflow','hidden');
    }
    /**
     * Cerramos el modal
     * Cambiamos la variable de la animacion
     * le aplicamos el estilo display none y le removemos la
     * clase ngx-utilitario-modal-open que permite visualizar el componente
     * @return {?}
     */
    close() {
        this.openclose = 'closed';
        this.element.style.display = 'none';
        this.renderer.removeClass(this.document.body, 'ngx-utilitario-modal-open');
        // this.renderer.setStyle(document.body, 'overflow', 'auto' )
    }
}
ModalComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-modal',
                template: "<div class=\"ngx-utilitario-modal\">\r\n  <div class=\"ngx-utilitario-modal-body\">\r\n    <div class=\"ngx-utilitario-modal-content\">\r\n      <div style=\"position: relative;\">\r\n        <button type=\"button\" class=\"ngx-utilitario-modal-cerrar\" (click)=\"close()\">\r\n          <span aria-hidden=\"true\">&times;</span>\r\n        </button>\r\n        <div class=\"ngx-utilitario-modal-ngcontent\" [@openClose]=\"openclose\">\r\n          <ng-content>\r\n          </ng-content>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<div class=\"ngx-utilitario-modal-background\" [@openCloseBackground]=\"openclose\"></div>\r\n<div class=\"ngx-utilitario-modal-open\"></div>",
                encapsulation: ViewEncapsulation.None,
                animations: [
                    trigger('openClose', [
                        // ...
                        state('open', style({
                            opacity: 1
                        })),
                        state('closed', style({
                            opacity: 0
                            // height: '0px',
                            // width: '0px',
                        })),
                        transition('open => closed', [
                            animate('0.35s')
                        ]),
                        transition('closed => open', [
                            animate('0.35s')
                        ]),
                    ]),
                    trigger('openCloseBackground', [
                        // ...
                        state('closed', style({
                            // top: '50%',
                            // right: '50%',
                            // bottom: '49%',
                            // left: '49%'
                            opacity: 0
                        })),
                        state('open', style({
                            // top: '0',
                            // right: '0',
                            // bottom: '0',
                            // left: '0'
                            opacity: 0.7
                        })),
                        transition('open => closed', [
                            animate('0.35s')
                        ]),
                        transition('closed => open', [
                            animate('0.35s')
                        ]),
                    ])
                ],
                styles: [".ngx-utilitario-modal{display:table;position:fixed;top:0;left:0;margin:15px 0 0;padding:0;height:100%;width:100%;z-index:1000}.ngx-utilitario-modal .ngx-utilitario-modal-body{display:table-cell;vertical-align:middle;padding:0;margin:0;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;height:-webkit-fit-content;height:-moz-fit-content;height:fit-content}.ngx-utilitario-modal .ngx-utilitario-modal-content{background:#fff;margin:0 auto;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;height:-webkit-fit-content;height:-moz-fit-content;height:fit-content;max-height:100%;padding:15px}.ngx-utilitario-modal .ngx-utilitario-modal-content .ngx-utilitario-modal-cerrar{opacity:1;font-size:18px;position:absolute;top:-30px;right:-30px;width:30px;height:30px;background-color:#fff;border-radius:100%;-moz-border-radius:100%;box-shadow:0 1px 2px rgba(0,0,0,.2);padding:0;z-index:901}.ngx-utilitario-modal .ngx-utilitario-modal-content .ngx-utilitario-modal-ngcontent{overflow-y:auto;max-height:-webkit-fill-available}.ngx-utilitario-modal-background{position:fixed;top:0;right:0;bottom:0;left:0;background-color:#000;opacity:.75;z-index:900;-webkit-animation-delay:2s;animation-delay:2s;-webkit-animation-duration:4s;animation-duration:4s;animation-direction:reverse}.ngx-utilitario-modal-open{overflow:hidden!important}"]
            }] }
];
/** @nocollapse */
ModalComponent.ctorParameters = () => [
    { type: ModalService },
    { type: ElementRef },
    { type: Renderer2 },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
ModalComponent.propDecorators = {
    id: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Modulo en el cual se trabajara los modales de la libreria
 */
class NgxUtilitarioModalModule {
}
NgxUtilitarioModalModule.decorators = [
    { type: NgModule, args: [{
                declarations: [ModalComponent],
                imports: [
                    CommonModule
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Chat component por el cual mostramos una lista de chat y una conversacion
 */
class ChatComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Lista de conversaciones a mostrar
         */
        this.list = [];
        /**
         * Conversacion actual a mostrar puede no estar en la lista
         */
        this.chatDetail = undefined;
        /**
         * Se envia un evento si se escribio un nuevo mensaje
         */
        this.messageNew = new EventEmitter();
        /**
         * Si hace click en una conversacion de la lista
         */
        this.listClick = new EventEmitter();
        /**
         * Si elimina la conversacion
         */
        this.chatDelete = new EventEmitter();
        /**
         * Si bloquea una conversacion
         */
        this.chatLock = new EventEmitter();
        /**
         * Variable en la cual se guardara la lista ingresada o la de busqueda
         */
        this.finalList = [];
        /**
         * Variable en la cual se guardara la lista de busqueda
         */
        this.searchList = [];
        /**
         * Flag que nos dira si hay una busqueda o no
         */
        this.searchFlag = false;
        /**
         * Texto a buscar
         */
        this.searchText = '';
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
        this.searchValidate();
    }
    /**
     * 1.- si el chat que se esta mostrando a cambiado sus mensajes
     * 2.- si existe una lista de busqued
     * @param {?} changes Si cambia algun item de la lista se actualizara
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.lista) {
            this.list.forEach((/**
             * @param {?} chat
             * @return {?}
             */
            chat => {
                if (chat.id === this.chatDetail.id) {
                    this.chatDetail.messages = chat.message;
                    this.chatDetail.lock = chat.lock;
                }
            }));
            this.searchValidate();
        }
    }
    /**
     * Si hay una busqueda activa no se actualiza la lista
     * @return {?}
     */
    searchValidate() {
        if (!this.searchFlag) {
            this.finalList = this.list;
            console.log('ingrese', this.finalList);
        }
        else {
            this.finalList = this.searchList;
            console.log('ingrese searc', this.finalList);
        }
    }
    /**
     * Si realiza un click en un item de la lista del chat cambiamos la conversacion
     * y emitimos un evento
     * @param {?} detalle propiedades de la conversacion
     * @return {?}
     */
    listDetailClick(detalle) {
        this.listClick.emit(detalle);
        this.changeDetail(detalle);
    }
    /**
     * Cambiamos conversacion actual y muestra la conversacion que tiene la lista por el usuario
     * @param {?} detail
     * @return {?}
     */
    changeDetail(detail) {
        /** @type {?} */
        const listTem = this.list.filter((/**
         * @param {?} list
         * @return {?}
         */
        list => list.id === detail.id))[0];
        this.chatDetail = {
            state: listTem.state,
            name: listTem.name,
            id: listTem.id,
            messages: listTem.message,
            img: listTem.img,
            lock: listTem.lock
        };
        this.moveToMessageIndex = this.moveToMessageIndexTem;
    }
    /**
     * Cuando el usuario envie un mensaje añadimos propiedad a la lista y realizamos un push
     * @param {?} mensaje propiedades del mensaje enviado
     * @return {?}
     */
    messageSend(mensaje) {
        this.moveToMessageIndex = undefined;
        this.chatDetail.messages.push(mensaje);
        this.messageNew.emit(this.chatDetail);
    }
    /**
     * Al eliminar mensajes emitiremos un evento y limpiaremos elementos
     * @return {?}
     */
    messageDelete() {
        this.chatDetail.messages = [];
        this.chatDelete.emit(this.chatDetail);
    }
    /**
     * Accion de bloquear chat
     * @param {?} estadoBloqueo los estados pueden ser desbloqueado, bloqueado, bloqueo
     * @return {?}
     */
    chatLocking(estadoBloqueo) {
        this.chatDetail.lock = estadoBloqueo;
        this.chatLock.emit(this.chatDetail);
    }
    /**
     * Comprobar si debe realizar una busqueda o no
     * @param {?} text
     * @return {?}
     */
    searchChange(text) {
        this.moveToMessageIndexTem = undefined;
        this.searchText = text;
        this.searchListClean();
        if (text.length > 0) {
            this.searchFlag = true;
            this.searchChatName(text);
            this.searchChatMessage(text);
        }
        else {
            this.searchFlag = false;
        }
        this.searchValidate();
    }
    /**
     * Buscamos en la lista actual en los nombres del chat
     * @param {?} text palabra a buscar
     * @return {?}
     */
    searchChatName(text) {
        this.list.forEach((/**
         * @param {?} chat
         * @return {?}
         */
        chat => {
            if (chat.name.includes(text)) {
                this.searchList.push(chat);
            }
        }));
    }
    /**
     * Buscamos en la lista actual los mensajes del chat y cambiamos el ultimo chat por el chat encontrado
     * @param {?} text palabra a buscar
     * @return {?}
     */
    searchChatMessage(text) {
        this.list.forEach((/**
         * @param {?} chat
         * @return {?}
         */
        chat => {
            // ya que necesitamos el index
            // tslint:disable-next-line: prefer-for-of
            for (let i = 0; i < chat.message.length; i++) {
                if (chat.message[i].message.includes(text)) {
                    this.moveToMessageIndexTem = i;
                    this.searchList.push({
                        id: chat.id,
                        img: chat.img,
                        lock: chat.lock,
                        message: [chat.message[i]],
                        name: chat.name,
                        notification: chat.notification,
                        state: chat.state
                    });
                    break;
                }
            }
        }));
    }
    /**
     * Limpiamos la lista de busqueda
     * @return {?}
     */
    searchListClean() {
        this.searchList = [];
    }
}
ChatComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat',
                template: "<div class=\"container-fluid row-no-padding ngx-utilitario-chat\" style=\"height: 400px\">\r\n  <div class=\"row\">\r\n    <div class=\"col-md-4 col-sm-12 ngx-utilitario-chat-list\">\r\n      <header class=\"ngx-util-list-header\">\r\n        Chats\r\n        <span class=\"fa fa-pencil-square-o\"></span>\r\n      </header>\r\n      <ngx-utilitario-chat-search class=\"ngx-util-list-search\" (searchChange)=\"searchChange($event)\">\r\n      </ngx-utilitario-chat-search>\r\n      <ngx-utilitario-chat-list class=\"ngx-util-list-detail\" [list]=\"finalList\" (clickList)=\"listDetailClick($event)\"\r\n        [search]=\"searchText\">\r\n      </ngx-utilitario-chat-list>\r\n    </div>\r\n    <div class=\"col-md-8 col-sm-12\">\r\n      <ngx-utilitario-chat-detail [chatDetail]=\"chatDetail\" [moveToMessage]=\"moveToMessageIndex\"\r\n        (newMessage)=\"messageSend($event)\" (deleteMessages)=\"messageDelete()\" (lockChat)=\"chatLocking($event)\">\r\n      </ngx-utilitario-chat-detail>\r\n    </div>\r\n  </div>\r\n</div>",
                styles: [".ngx-utilitario-chat{display:flex;flex-flow:column;height:21.87rem}.ngx-utilitario-chat-list{display:flex;flex-flow:column;height:100%}.ngx-util-list-header{background:#fff;color:#324148;padding:1.37rem .93rem;border-bottom:.06rem solid #e0e3e4;text-align:center;font-size:1.12rem;font-weight:600;font-family:Lato,sans-serif;height:4.37rem}.ngx-util-list-header span{float:right;font-size:inherit}.ngx-util-list-detail{flex-grow:1;overflow:hidden}::ng-deep .scrollable-content{padding:0!important}"]
            }] }
];
/** @nocollapse */
ChatComponent.ctorParameters = () => [];
ChatComponent.propDecorators = {
    list: [{ type: Input }],
    chatDetail: [{ type: Input }],
    messageNew: [{ type: Output }],
    listClick: [{ type: Output }],
    chatDelete: [{ type: Output }],
    chatLock: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente que buscara palabras o chats
 */
class ChatSearchComponent {
    /**
     * @ignore
     * @param {?} formBuilder
     */
    constructor(formBuilder) {
        this.formBuilder = formBuilder;
        /**
         * Emitimos el valor de la busqueda
         */
        this.searchChange = new EventEmitter();
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
        this.createForm();
    }
    /**
     * Creamos el form
     * @return {?}
     */
    createForm() {
        this.searchForm = this.formBuilder.group({
            search: ''
        });
    }
    /**
     * Emitimos cambio
     * @return {?}
     */
    changeValue() {
        this.searchChange.emit(this.searchForm.controls.search.value);
    }
}
ChatSearchComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat-search',
                template: "<div class=\"content ngx-util-search\">\n  <ngx-utilitario-input class=\"w-100 ngx-util-search-input\" label=\"busqueda\" iconMatSuffix=\"fa fa-search\"\n    [parent]=\"searchForm\" name=\"search\" (value)=\"changeValue()\"></ngx-utilitario-input>\n</div>",
                styles: [".ngx-util-search{padding:1rem;background:#ececec;box-sizing:border-box}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline{background-color:#ececec;border-radius:3rem!important}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline-start{border-radius:3rem 0 0 3rem!important;padding-left:30px}::ng-deep .mat-form-field-label-wrapper{top:-1.2em}::ng-deep .mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label{-webkit-transform:translate(1.5em,-1.3em) scale(.7)!important;transform:translate(1.5em,-1.3em) scale(.7)!important;width:133.33333%}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline-end{border-radius:0 3rem 3rem 0!important}::ng-deep .mat-input-element{padding-left:.7rem!important}::ng-deep .mat-form-field-wrapper{padding-bottom:0!important}"]
            }] }
];
/** @nocollapse */
ChatSearchComponent.ctorParameters = () => [
    { type: FormBuilder }
];
ChatSearchComponent.propDecorators = {
    searchChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente que muestra todas las conversaciones que tienes
 */
class ChatListComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Lista de chats que tienes
         */
        this.list = [];
        /**
         * Si se desea resaltar un texto en la lista de un chat
         */
        this.search = '';
        /**
         * Si hace click en una conversacion retornara un evento
         */
        this.clickList = new EventEmitter();
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * retorna el chat que realiza click
     * @param {?} detail las propiedades del chat
     * @return {?}
     */
    click(detail) {
        this.clickList.emit(detail);
    }
}
ChatListComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat-list',
                template: "<ngx-utilitario-perfect-scroll>\r\n    <ngx-utilitario-chat-list-detail *ngFor=\"let item of list\" [listDetail]=\"item\" [search]=\"search\" (clickDetail)=\"click($event)\"></ngx-utilitario-chat-list-detail>\r\n</ngx-utilitario-perfect-scroll>"
            }] }
];
/** @nocollapse */
ChatListComponent.ctorParameters = () => [];
ChatListComponent.propDecorators = {
    list: [{ type: Input }],
    search: [{ type: Input }],
    clickList: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const moment = _moment;
/**
 * Clase que trabajara sobre el tipo de dato "date" con la libreria "moment"
 */
class Fecha {
    /**
     * Obtiene la fecha actual
     */
    constructor() {
        this.now = new Date();
    }
    /**
     * Comparar dos fechas
     * \@example
     *  this.fecha.compareDates(new Date())
     *  this.fecha.compareDates(new Date(), '2019-10-13')
     * @param {?} date1 fecha a comparar
     * @param {?=} date2 si no envia una fecha se tomara la fecha actual
     * @return {?} retorna true si la fecha1 es mayor a la fecha2
     */
    compareDates(date1, date2) {
        if (date1 === undefined || date1 === null) {
            return false;
        }
        /** @type {?} */
        const dat1 = moment(date1);
        if (date2 === undefined || date2 === null) {
            date2 = new Date();
        }
        /** @type {?} */
        const dat2 = moment(date2);
        if (dat1.startOf('day').isSame(dat2.startOf('day'))) {
            return true;
        }
        return false;
    }
    /**
     * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
     * \@example
     *  this.fecha.DifferenceDays(new Date())
     *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
     * @param {?} date1 fecha a comparar si es undefined retornara undefined
     * @param {?=} date2 si no envia una fecha se tomara la fecha actual
     * @return {?} retorna los dias de diferencia o undefined si los datos son enviados incorrectamente
     */
    differenceDays(date1, date2) {
        if (date1 !== undefined && date1 !== null && date2 !== null) {
            if (!isNaN(date1.getTime())) {
                /** @type {?} */
                const dat1 = moment(date1);
                if (date2 === undefined) {
                    date2 = new Date();
                }
                if (!isNaN(date2.getTime())) {
                    /** @type {?} */
                    const dat2 = moment(date2);
                    return dat1.diff(dat2, 'days', false);
                }
            }
        }
        return undefined;
    }
    /**
     * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
     * \@example
     *  this.fecha.DifferenceDays(new Date())
     *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
     *  this.fecha.DifferenceDays(new Date(), '2019-10-13', 'DD/MM/YYYY')
     * @param {?} date1 fecha a comparar
     * @param {?=} date2 si no envia una fecha se tomara la fecha actual
     * @param {?=} format  en este formato se retornara la fecha  en formato de moment por defecto tiene el formato DD/MM/YYYY
     *
     * @return {?} si la diferencia es entre -1 o 1 retornara ayer hoy o mañana si no retornara la fecha en el formato indicado
     */
    differenceDaysText(date1, date2, format) {
        if (date1 !== undefined && date1 !== null && date2 !== null) {
            if (!isNaN(date1.getTime())) {
                /** @type {?} */
                const dat1 = moment(date1);
                /** @type {?} */
                const dias = this.differenceDays(date1, date2);
                if (format === undefined) {
                    format = 'DD/MM/YYYY';
                }
                switch (dias) {
                    case 0: {
                        return 'Hoy';
                    }
                    case 1: {
                        return 'Mañana';
                    }
                    case -1: {
                        return 'Ayer';
                    }
                    default: {
                        return dat1.format(format);
                    }
                }
            }
        }
        return undefined;
    }
    /**
     * Cambia el formato de la fecha en formato de moment
     * \@example
     *  this.fecha.DifferenceDays(new Date(), 'DD/MM/YYYY')
     *  YYYY    4-digits Year                                                   2018
     *  YY      2-digits Year                                                   18
     *  M       2-digits Month number, omits leading 0                          7
     *  MM      2-digits Month number                                           07
     *  MMM     3-letters Month name                                            Jul
     *  MMMM    Full Month name                                                 July
     *  dddd    Full day name                                                   Sunday
     *  gggg    4-digits Week year                                              2018
     *  gg      2-digits Week year                                              18
     *  w       Week of the year without leading zero                           18
     *  ww      Week of the year with leading zero                              18
     *  e       Day of the week, starts at 0                                    4
     *  D       2-digits day number, omits leading 0                            9
     *  DD      2-digits day number                                             09
     *  Do      Day number with ordinal                                         9th
     *  T       Indicates the start of the time part
     *  HH      2-digits hours (24 hour time) from 0 to 23                      22
     *  H       2-digits hours (24 hour time) from 0 to 23 without leading 0    22
     *  kk      2-digits hours (24 hour time) from 1 to 24                      23
     *  k       2-digits hours (24 hour time) from 1 to 24 without leading 0    23
     *  a/A     am or pm	                                                    pm
     *  hh      2-digits hours (12 hour time)                                   11
     *  mm      2-digits minutes	                                            22
     *  ss      2-digits seconds	                                            40
     *  s       2-digits seconds without leading zero                           40
     *  S       1-digits milliseconds                                           1
     *  SS      2-digits milliseconds                                           12
     *  SSS     3-digits milliseconds                                           123
     *  Z       The timezone                                                    +02:00
     *  x       UNIX timestamp in milliseconds                                  1410432140575
     *
     * @param {?} date fecha a cambiar el formato
     * @param {?} format formato que se desea la fecha
     *
     * @return {?} la fecha en el formato deseado
     */
    format(date, format) {
        if (date !== undefined && date !== null) {
            if (!isNaN(date.getTime())) {
                /** @type {?} */
                const dat1 = moment(date);
                return dat1.format(format);
            }
        }
        return undefined;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Variables para utilizar en la libreria
 * @type {?}
 */
const environment = {
    production: false,
    // tslint:disable-next-line: max-line-length
    imgUsuario: 'https://firebasestorage.googleapis.com/v0/b/ngx-utilitario-rclt.appspot.com/o/default-user.jpg?alt=media&token=bac4339b-4cfa-4751-9fcf-8090950c7d84',
    // tslint:disable-next-line: max-line-length
    chatWifi: 'https://firebasestorage.googleapis.com/v0/b/ngx-utilitario-rclt.appspot.com/o/wifi.png?alt=media&token=a90ade22-6aa5-4200-9aa4-b5438c2713ab'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente que muestra la lista de conversaciones
 */
class ChatListDetailComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Caracteristicas de una conversacion
         */
        this.listDetail = undefined;
        /**
         * El mensaje a mostrar cuando se envie una imagen
         */
        this.imageName = 'Foto';
        /**
         * Si se desea resaltar un texto en el chat
         */
        this.search = '';
        /**
         * Retorna un evento cuando cuando cuando hace click en una conversacion
         */
        this.clickDetail = new EventEmitter();
        this.date = new Fecha();
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * Si realiza un click en una conversacion
     * @return {?}
     */
    click() {
        this.clickDetail.emit(this.listDetail);
    }
    /**
     * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
     * debe estar ordenado los mensajes
     * @param {?} messages recibe todos los mensajes de la conversacion
     * @return {?}
     */
    messageLast(messages) {
        if (messages !== undefined && messages !== null) {
            if (messages.length > 0) {
                if (messages[messages.length - 1].img === null ||
                    messages[messages.length - 1].img === undefined ||
                    messages[messages.length - 1].img === '') {
                    return messages[messages.length - 1].message;
                }
                else {
                    return this.imageName;
                }
            }
        }
        return '';
    }
    /**
     * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
     * debe estar ordenado los mensajes
     * @param {?} messages recibe todos los mensajes de la conversacion
     * @return {?}
     */
    dateLast(messages) {
        if (messages !== undefined && messages !== null) {
            if (messages.length > 0) {
                if (!isNaN(new Date(messages[messages.length - 1].date).getTime())) {
                    if (this.date.differenceDays(new Date(messages[messages.length - 1].date))) {
                        return messages[messages.length - 1].date;
                    }
                    else {
                        return messages[messages.length - 1].hour;
                    }
                }
            }
        }
        return '';
    }
    /**
     * Funcion para verficar el estado actual del usuario con el que se esta conversando
     * @param {?} listDetail propiedades de la conversacion conectado, desconectado
     * @return {?}
     */
    chatState(listDetail) {
        if (listDetail !== undefined) {
            return listDetail.state;
        }
        else {
            return false;
        }
    }
    /**
     * Si la imagen es null, undefined o vacia utilizar una por defecto
     * @param {?} listDetail
     * @return {?} la imagen o una por va
     */
    imageValidate(listDetail) {
        if (listDetail !== null && listDetail !== undefined) {
            if (listDetail.img !== '' && listDetail.img !== undefined && listDetail.img !== null) {
                return listDetail.img;
            }
        }
        return environment.imgUsuario;
    }
    /**
     * Validamos si mostramos una validacion o no
     * @param {?} notification
     * @return {?}
     */
    notificationValidate(notification) {
        if (notification !== undefined && notification !== null) {
            if (notification > 0) {
                return true;
            }
        }
        return false;
    }
    /**
     * Obtener nombre
     * @param {?} listDetail
     * @return {?}
     */
    validateListDetail(listDetail) {
        if (listDetail !== undefined && listDetail !== null) {
            return true;
        }
        return false;
    }
}
ChatListDetailComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat-list-detail',
                template: "<div id=\"div_detailMessages\" class=\"content ngx-util-chat-detail\" (click)=\"click()\"\r\n  *ngIf=\"validateListDetail(listDetail)\">\r\n  <!--Imagen-->\r\n  <div class=\"list-detail-img\">\r\n    <img class=\"img-fluid rounded-circle\" title=\"listDetail.name\" alt=\"User Image\" src={{imageValidate(listDetail)}} />\r\n    <div *ngIf=\"chatState(listDetail)\" class=\"list-detail-img-state\"></div>\r\n  </div>\r\n  <!--Nombre y mensaje-->\r\n  <div class=\"list-detail-name\">\r\n    <div class=\"name\" innerHTML=\"{{ listDetail.name | highlight : search}}\"></div>\r\n    <div class=\"message\"  innerHTML=\"{{ messageLast(listDetail.message) | highlight : search}}\"></div>\r\n  </div>\r\n  <!--fecha y notifiaciones-->\r\n  <div class=\"list-detail-date\">\r\n    <div class=\"date\">\r\n      {{dateLast(listDetail.message)}}\r\n    </div>\r\n    <div *ngIf=\"notificationValidate(listDetail.notification)\" class=\"badge badge-success badge-pill notification\">\r\n      {{listDetail.notification}}\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                styles: [".ngx-util-chat-detail{display:flex;width:98%;margin-left:.3rem;border-bottom:1px solid #e0e3e4;padding:.5rem .8rem;cursor:pointer}.ngx-utili-date-not-chat{padding:0}.ngx-util-date-chat{font-size:.7rem}.list-detail-img-state{background:#22af47;border:.06rem solid #fff;width:.62rem;height:.62rem;position:absolute;border-radius:50%;right:.12rem;bottom:.12rem}.list-detail-img{position:relative;width:2.8rem;min-width:2rem;margin-right:.5rem}.list-detail-name{flex:1 1 auto}.list-detail-name .name{font-size:.875rem;font-weight:700;color:#324148}.list-detail-name .message{font-size:.815rem;color:#b0b0b0;text-overflow:ellipsis}.list-detail-date{flex:0 0 auto}.list-detail-date .date{font-size:.815rem;color:#5e7d8a}.list-detail-date .notification{background-color:#e7b723;padding:.25rem .5rem;float:right}"]
            }] }
];
/** @nocollapse */
ChatListDetailComponent.ctorParameters = () => [];
ChatListDetailComponent.propDecorators = {
    listDetail: [{ type: Input }],
    imageName: [{ type: Input }],
    search: [{ type: Input }],
    clickDetail: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const EMessageType = {
    /**
     * si yo he enviado el mensaje
     */
    sent: 1,
    /**
     * si yo he recibido el mensaje
     */
    recived: 0,
};
EMessageType[EMessageType.sent] = 'sent';
EMessageType[EMessageType.recived] = 'recived';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const EMessageState = {
    /**
     * Mensaje enviado
     */
    sent: 0,
    /**
     * Mensaje recibido
     */
    received: 1,
    /**
     * Mensaje leido
     */
    read: 2,
};
EMessageState[EMessageState.sent] = 'sent';
EMessageState[EMessageState.received] = 'received';
EMessageState[EMessageState.read] = 'read';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const EChatLock = {
    /**
     * Si el chat esta desbloqueado
     */
    unlocked: 0,
    /**
     * Si yo eh bloqueado el chat
     */
    lock: 1,
    /**
     * Si he sido bloqueado
     */
    locked: 2,
};
EChatLock[EChatLock.unlocked] = 'unlocked';
EChatLock[EChatLock.lock] = 'lock';
EChatLock[EChatLock.locked] = 'locked';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const EScrollPosition = {
    /**
     * Si se dedea ir al inicio
     */
    start: 0,
    /**
     * Si se desea ir al final
     */
    end: -1,
};
EScrollPosition[EScrollPosition.start] = 'start';
EScrollPosition[EScrollPosition.end] = 'end';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente donde mostramos los mensajes de la conversacion
 */
class ChatDetailComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Las caracteristicas de la conversacion
         * Si se envia null en lock no podra bloquear ni desbloquear un chat
         */
        this.chatDetail = undefined;
        // TODO Eliminar al probarlo
        // @Input() chatDetail: IChatDetail = {
        //   id: '',
        //   img: '',
        //   name: 'renato',
        //   state: null,
        //   messages: [],
        //   lock: EChatLock.unlocked
        // };
        /**
         * Alt en icono de trash
         */
        this.messageTrashIcon = 'eliminar conversacion';
        /**
         * Alt en icono de trash
         */
        this.messageLockIcon = 'bloquear conversacion';
        /**
         * Alt en icono de trash
         */
        this.messageUnlockIcon = 'desbloquear conversacion';
        /**
         * Imagen a mostrar en el chat cuando chatDetail esta vacio
         */
        this.imageChat = environment.chatWifi;
        /**
         * Al enviar un nuevo mensaje
         */
        this.newMessage = new EventEmitter();
        /**
         * Al eliminar la conversacion
         */
        this.deleteMessages = new EventEmitter();
        /**
         * Al bloquear una conversacion
         */
        this.lockChat = new EventEmitter();
        /**
         * Variable para usar un enum en html
         */
        this.EChatLock = EChatLock;
        /**
         * posicion del scroll
         */
        this.position = [EScrollPosition.start, EScrollPosition.end];
    }
    /**
     * Se validara si el cambio es de movetomessage
     * Validara si se cambio de chat y eliminar previsualizacion
     * @param {?} changes index del mensaje a mostrar
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.moveToMessage) {
            this.messageMove(changes.moveToMessage.currentValue);
        }
        if (changes.chatDetail) {
            this.filesPreview = undefined;
        }
    }
    /**
     * Emitimos un nuevo mensaje y añadimos el mensaje
     * si no tiene mensajes ni imagenes no realizara ningua accion
     * @param {?} message mensaje enviado
     * @return {?}
     */
    messageSend(message) {
        console.log('prueba', this.filesPreview, message);
        if ((message === '' || message === null) && this.filesPreview === undefined) {
            return;
        }
        /** @type {?} */
        let newMessage;
        if (this.filesPreview === undefined) {
            newMessage = {
                messageState: EMessageState.sent,
                date: new Fecha().format(new Date(), 'LL'),
                hour: new Fecha().format(new Date(), 'HH:mm'),
                img: undefined,
                message,
                messageType: EMessageType.sent
            };
            this.newMessage.emit(newMessage);
        }
        else {
            Array.from(this.filesPreview).forEach((/**
             * @param {?} file
             * @return {?}
             */
            (file) => {
                newMessage = {
                    messageState: EMessageState.sent,
                    date: new Fecha().format(new Date(), 'LL'),
                    hour: new Fecha().format(new Date(), 'HH:mm'),
                    img: file,
                    message,
                    messageType: EMessageType.sent
                };
                this.newMessage.emit(newMessage);
            }));
            this.filesPreview = undefined;
        }
    }
    /**
     * imagePreview
     * @param {?} fileList imagenes Seleccionadas
     * @return {?}
     */
    imagePreview(fileList) {
        this.filesPreview = fileList;
    }
    /**
     * Se eliminaran los mensajes en esta conversacion
     * @return {?}
     */
    chatDelete() {
        this.deleteMessages.emit();
    }
    /**
     * Se bloqueara la conversacion
     * @return {?}
     */
    lock() {
        this.chatDetail.lock = EChatLock.lock;
        this.lockChat.emit(EChatLock.lock);
    }
    /**
     * Se desbloqueara la conversacion
     * @return {?}
     */
    unlock() {
        this.chatDetail.lock = EChatLock.unlocked;
        this.lockChat.emit(EChatLock.unlocked);
    }
    /**
     * Valida si el estado es el esperado
     * @param {?} state bloqueo, bloqueado o desbloqueado
     * @param {?} expetedState
     * @return {?}
     */
    lookStateValidate(state, expetedState) {
        if (state === expetedState) {
            return true;
        }
        return false;
    }
    /**
     * Si la imagen es null, undefined o vacia utilizar una por defecto
     * @param {?} image url o ubicacion de la imagen
     * @return {?} la imagen o una por va
     */
    imageValidate(image) {
        if (image === null || image === undefined || image === '') {
            return environment.imgUsuario;
        }
        else {
            return image;
        }
    }
    /**
     * Validaremos la variable chat detail
     * @return {?}
     */
    validateChatDetail() {
        if (this.chatDetail === undefined || this.chatDetail === null) {
            return false;
        }
        return true;
    }
    /**
     * Cambiar el estado de 1 o 0 a letras
     * @param {?} state Enum del estado actual
     * @return {?}
     */
    nameState(state) {
        if (state === 1) {
            return 'Online';
        }
        return 'Offline';
    }
    /**
     * Vamos a mover al mensaje indicado
     * @param {?} id id del mensaje a moverse
     * @return {?}
     */
    messageMove(id) {
        if (id !== undefined) {
            this.elementName = 'message_' + id;
        }
        else {
            this.elementName = undefined;
        }
    }
    /**
     * Cerrar la ventanta preview
     * @return {?}
     */
    closePreview() {
        this.filesPreview = undefined;
    }
}
ChatDetailComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat-detail',
                template: "<!--Si es invalido chatdetail mostraremos una imagen-->\r\n<div class=\"container-fluid ngx-util-detail no-margin no-padding\" *ngIf=\"!validateChatDetail()\"\r\n  style=\"background: #ffe4c4\">\r\n  <img class=\"ngx-util-img-height-res-center\" title=\"Chat\" alt=\"Chat Image\" src={{imageChat}} />\r\n</div>\r\n<!--Si es valido chatdetail mostraremos el chat-->\r\n<div class=\"container-fluid ngx-util-detail no-margin no-padding\" *ngIf=\"validateChatDetail()\">\r\n  <!--Cabecera del chat-->\r\n  <div class=\"row ngx-util-detail-head no-margin\">\r\n    <div class=\"img-fluid detail-head-img\">\r\n      <img class=\"img-fluid rounded-circle img-profile-chat-detail\" alt=\"chatDetail.name\"\r\n        src=\"{{imageValidate(chatDetail.img)}}\" />\r\n    </div>\r\n    <div class=\"detail-head-name\">\r\n      <div class=\"row\">\r\n        <div class=\"col-12\">\r\n          {{chatDetail.name}}\r\n        </div>\r\n      </div>\r\n      <div class=\"row\">\r\n        <div class=\"col-12 detail-head-state-letters\">{{nameState(chatDetail.state)}}</div>\r\n      </div>\r\n    </div>\r\n    <div class=\"detail-head-actions no-padding\">\r\n      <div class=\"ngx-util-btns-actions\">\r\n        <button id=\"btn_chatDelete\" type=\"button\" class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\"\r\n          (click)=\"chatDelete()\" title=\"{{messageTrashIcon}}\">\r\n          <i class=\"fa fa-trash-o\" style=\"color: #808080\" aria-hidden=\"true\" title=\"{{messageTrashIcon}}\"></i>\r\n        </button>\r\n        <button id=\"btn_chatLock\" *ngIf=\"lookStateValidate(chatDetail.lock, EChatLock.unlocked)\" type=\"button\"\r\n          class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" (click)=\"lock()\" title=\"{{messageLockIcon}}\">\r\n          <i class=\"fa fa-ban\" style=\"color: #c2272d\" aria-hidden=\"true\" title=\"{{messageLockIcon}}\"></i>\r\n        </button>\r\n        <button id=\"btn_chatUnlock\" *ngIf=\"lookStateValidate(chatDetail.lock, EChatLock.lock)\" type=\"button\"\r\n          class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" title=\"{{messageUnlockIcon}}\" (click)=\"unlock()\">\r\n          <i class=\"fa fa-unlock\" style=\"color: #228B22\" aria-hidden=\"true\" title=\"{{messageUnlockIcon}}\"></i>\r\n        </button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <!--Mensajes del chat-->\r\n  <div class=\"ngx-util-detail-messages\" style=\"background: rgb(245, 245, 246);\" *ngIf=\"filesPreview === undefined\">\r\n    <ngx-utilitario-perfect-scroll [position]=\"position\" [elementName] = \"elementName\" >\r\n      <ngx-utilitario-chat-detail-message [messages]=\"chatDetail.messages\"></ngx-utilitario-chat-detail-message>\r\n    </ngx-utilitario-perfect-scroll>\r\n  </div>\r\n  <div *ngIf=\"filesPreview !== undefined\">\r\n    <ngx-utilitario-chat-detail-preview [files]=\"filesPreview\" (close)=\"closePreview()\"></ngx-utilitario-chat-detail-preview>\r\n  </div>\r\n  <!--Agregar chat-->\r\n  <div class=\"container-fluid ngx-util-detail-add\">\r\n    <div class=\"row\">\r\n      <ngx-utilitario-chat-detail-add class=\"col-12 ngx-utilitario-chat-agregar\" (newMessage)=\"messageSend($event)\" (newImage)=\"imagePreview($event)\"\r\n        [disabled]=\"chatDetail.lock\"></ngx-utilitario-chat-detail-add>\r\n    </div>\r\n  </div>\r\n</div>",
                styles: [".ngx-util-detail{display:flex;flex-flow:column;width:100%;height:100%;border:.0625rem solid #e0e3e4;overflow:hidden}.ngx-util-detail-head{padding:.62rem .93rem;height:4.37rem;border-bottom:.0625rem solid #e0e3e4}.detail-head-img{position:relative;width:4.8rem;min-width:2rem;margin-right:.5rem}.img-profile-chat-detail{height:3.125rem}.detail-head-name{font-size:1rem;font-weight:700;flex:1 1 auto;color:#324148}.detail-head-state-letters{font-size:.75rem;width:3rem;color:#b0b0b0}.detail-head-actions{flex:0 0 auto}.ngx-util-detail-messages{flex-grow:1;overflow:hidden;height:-webkit-fill-available;overflow-y:hidden}.ngx-util-detail-messages-show{height:100%;background:#000}.ngx-util-detail-add{height:4.37rem}"]
            }] }
];
/** @nocollapse */
ChatDetailComponent.ctorParameters = () => [];
ChatDetailComponent.propDecorators = {
    chatDetail: [{ type: Input }],
    messageTrashIcon: [{ type: Input }],
    messageLockIcon: [{ type: Input }],
    messageUnlockIcon: [{ type: Input }],
    imageChat: [{ type: Input }],
    moveToMessage: [{ type: Input }],
    newMessage: [{ type: Output }],
    deleteMessages: [{ type: Output }],
    lockChat: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente que permite agregar un mensaje y una nueva imagen
 */
class ChatDetailAddComponent {
    /**
     * @ignore
     * @param {?} formBuilder inicializacion de formulario
     */
    constructor(formBuilder) {
        this.formBuilder = formBuilder;
        /**
         * Validamos si puede escribir o no un mensaje
         * \@example
         * 0 si puede enviar un mensaje
         * 1 no puede enviar mensaje
         * 2 no puede enviar mensaje
         */
        this.disabled = 0;
        /**
         * Mensaje que aparecera en la caja de texto
         */
        this.placeholder = 'Escribir mensaje ...';
        /**
         * Al enviar un mensaje emite un evento
         */
        this.newMessage = new EventEmitter();
        /**
         * Al enviar una imagen emite un evento con todos los archivos cargados
         */
        this.newImage = new EventEmitter();
    }
    /**
     * Inicializamos el formulario
     * @return {?}
     */
    ngOnInit() {
        this.createForm();
    }
    /**
     * añadimos el control mensaje e imagen al formulario
     * @return {?}
     */
    createForm() {
        this.messageForm = this.formBuilder.group({
            message: '',
        });
    }
    /**
     * Emitimos de que hay un nuevo mensaje y limpiamos la caja de texto
     * @return {?}
     */
    sendMessage() {
        this.newMessage.emit(this.messageForm.controls.message.value);
        this.messageForm.reset();
    }
    /**
     * Emitimos de que hay una nueva imagen a enviar
     * @param {?} event
     * @return {?}
     */
    sendImage(event) {
        /** @type {?} */
        const target = (/** @type {?} */ (event.target));
        /** @type {?} */
        const fileList = target.files;
        if (fileList && fileList.length > 0) {
            this.newImage.emit(fileList);
        }
    }
}
ChatDetailAddComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat-detail-add',
                template: "<div class=\"container-fluid\">\r\n  <div class=\"row ngx-util-detail-add no-margin\">\r\n    <!--Input-->\r\n    <div class=\"col-11\">\r\n      <form [formGroup]=\"messageForm\">\r\n        <input id=\"txt_message\" class=\"col-12\" formControlName=\"message\" [attr.disabled]=\"disabled ? '' : null\"\r\n        [placeholder]=\"placeholder\" (keyup.enter)=\"sendMessage()\">\r\n      </form>\r\n    </div>\r\n    <!--Acciones-->\r\n    <div class=\"col-1 no-padding\">\r\n      <div class=\"ngx-util-btns-actions\">\r\n        <input class=\"ngx-util-input-file\" type=\"file\" accept=\"image/*\" #file (change)=\"sendImage($event)\" multiple>\r\n        <button id=\"btn_sendImage\" type=\"button\" class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" (click)=\"file.click()\" [attr.disabled]=\"disabled ? '' : null\"><i\r\n            class=\"fa fa-camera\" aria-hidden=\"true\"></i></button>\r\n        <button id=\"btn_sendMessage\" type=\"button\" class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" [attr.disabled]=\"disabled ? '' : null\"\r\n          (click)=\"sendMessage()\"><i class=\"fa fa-paper-plane\" aria-hidden=\"true\"></i></button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>",
                styles: [".no-padding{padding-left:0!important;padding-right:0!important}.ngx-util-detail-add{padding:.95rem;background:#fff;display:flex}.ngx-util-detail-add input{background:#f5f5f6;border-radius:4.5rem;box-shadow:none;display:inline-block;padding:.9rem!important;font-size:.8rem;border:none;flex:1 1 auto}.ngx-util-btns-actions{flex:0 0 auto;width:3rem}"]
            }] }
];
/** @nocollapse */
ChatDetailAddComponent.ctorParameters = () => [
    { type: FormBuilder }
];
ChatDetailAddComponent.propDecorators = {
    disabled: [{ type: Input }],
    placeholder: [{ type: Input }],
    newMessage: [{ type: Output }],
    newImage: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente que muestra los mensajes de un chat
 */
class ChatDetailMessageComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Variable para usar enum en html
         */
        this.EMessageState = EMessageState;
        this.date = new Fecha();
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * Si el index es 0 a la fecha enviada se le restara un dia para que retorne true y genere una linea
     * Si el index es mayor a 0 tomara la fecha del mensaje anterior y la comparara
     * si se envia un undefined un null o una fecha invalidad no imprimira linea
     * @param {?} dateString
     * @param {?} index index del elemento en el arreglo
     * @return {?} si debe mostrar una linea o no
     */
    dayLine(dateString, index) {
        /** @type {?} */
        let date;
        if (dateString !== null && dateString !== undefined && dateString !== '') {
            date = new Date(dateString);
            if (!isNaN(date.getTime())) {
                /** @type {?} */
                let tDate;
                if (index === 0) {
                    tDate = new Date(date);
                    tDate.setDate(tDate.getDate() - 1);
                }
                else {
                    tDate = new Date(this.messages[index - 1].date);
                }
                return !this.date.compareDates(new Date(date), tDate);
            }
        }
        return false;
    }
    /**
     * Compara los dias entre la fecha actual y la enviada para insertar el texto en el chat
     * @param {?} date fecha del mensaje
     * @return {?}
     */
    dayDifference(date) {
        /** @type {?} */
        const temDate = this.date.differenceDaysText(new Date(date));
        return temDate !== undefined ? temDate : '';
    }
    /**
     * Validamos si el tipo de mensaje es enviado
     * @param {?} state estado actual del mensaje
     * @param {?} messageType enviado o recibido
     * @param {?} stateSearch tipo que se consulta
     * @return {?}
     */
    messageState(state, messageType, stateSearch) {
        if (state === stateSearch && messageType === EMessageType.sent) {
            return true;
        }
        return false;
    }
    /**
     * Insertamos el estilo al mensaje dependiendo el tipo del mensaje
     * @param {?} messageType si es recibido o enviado
     * @return {?}
     */
    chooseStyle(messageType) {
        if (messageType === EMessageType.sent) {
            return 'ngx-util-chat-right float-right arrow_box';
        }
        return 'ngx-util-chat-left float-left';
    }
    /**
     * Validaremos si debe mostrar el mensaje o no
     * @param {?} message mensaje recibido
     * @return {?}
     */
    validateMessage(message) {
        if (message === '' || message === undefined || message === null) {
            return false;
        }
        return true;
    }
    /**
     * Validaremos si debe mostrar imagen o no
     * si mostramos una imagen pasaremos el Filelist a DataUrl
     * @param {?} message
     * @return {?}
     */
    validateImage(message) {
        if (message.img === '' || message.img === undefined || message.img === null) {
            return false;
        }
        if (typeof (message.img) !== 'string') {
            if (message.imgUrl === undefined) {
                this.messageImageUrl(message.img, message);
            }
        }
        else {
            message.imgUrl = message.img;
        }
        return true;
    }
    /**
     * Parseara el data enviado a una url
     * @param {?} image Ruta de la image o el archivo de la imagen
     * @param {?} message
     * @return {?} la imagen
     */
    messageImageUrl(image, message) {
        if (image) {
            /** @type {?} */
            const mimeType = image.type;
            if (mimeType.match(/image\/*/) == null) {
                return;
            }
            /** @type {?} */
            const reader = new FileReader();
            reader.onload = (/**
             * @param {?} e
             * @return {?}
             */
            (e) => {
                message.imgUrl = e.target.result;
            });
            reader.readAsDataURL(image);
        }
    }
}
ChatDetailMessageComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat-detail-message',
                template: "<div id=\"message_{{i}}\" class=\"col-12\" class=\"ngx-util-detail-message\" *ngFor=\"let item of messages; let i=index \">\n    <div class=\"container-fluid\">\n      <div class=\"row\" *ngIf=\"dayLine(item.date,i)\">\n        <div class=\"w-100 ngx-util-chat-linea\">\n          <span class=\"ngx-util-chat-linea-span\">\n            {{dayDifference(item.date)}}\n          </span>\n        </div>\n      </div>\n    </div>\n    <div class=\"container-fluid\"  >\n      <div [ngClass]=\"chooseStyle(item.messageType)\">\n        <div *ngIf=\"validateImage(item)\">\n          <img src=\"{{item.imgUrl}}\" alt=\"Message\" class=\"img-message\">\n        </div>\n        <div *ngIf=\"validateMessage(item.message)\" class=\"message\">{{item.message}}</div>\n        <div class=\"hour\">{{item.hour}}\n          <span *ngIf=\"messageState(item.messageState, item.messageType, EMessageState.sent )\"\n            class=\"ngx-util-msg-sent\">\n            <em class=\"fa fa-check\"></em>\n          </span>\n          <span *ngIf=\"messageState(item.messageState, item.messageType, EMessageState.received)\"\n            class=\"ngx-util-msg-received\">\n            <em class=\"fa fa-check\"></em>\n            <em class=\"fa fa-check\"></em>\n          </span>\n          <span *ngIf=\"messageState(item.messageState, item.messageType, EMessageState.read )\"\n            class=\"ngx-util-msg-read\">\n            <em class=\"fa fa-check\"></em>\n            <em class=\"fa fa-check\"></em>\n          </span>\n        </div>\n      </div>\n    </div>\n  </div>",
                styles: [".ngx-util-detail-message{background:inherit;display:flow-root}.ngx-util-chat-linea{position:relative;text-align:center;overflow:hidden;font-size:.87rem;margin:.93rem 3.125rem;text-transform:capitalize;color:#9e9e9e}.ngx-util-chat-linea::before{background:#e0e3e4;content:\"\";height:.0625rem;right:50%;margin-right:2.5rem;position:absolute;top:50%;width:100%}.ngx-util-chat-linea::after{background:#e0e3e4;content:\"\";height:.0625rem;left:50%;margin-left:2.5rem;position:absolute;top:50%;width:100%}.ngx-util-chat-right{background:#e7b723;padding:.3125rem .9375rem;border-radius:.25rem;display:inline-block;position:relative;margin-bottom:.3125rem;word-wrap:break-word;max-width:60%;color:#fff;text-align:right}.ngx-util-chat-left{background:#fff;padding:.3125rem .9375rem;border-radius:.25rem;display:inline-block;position:relative;margin-bottom:.3125rem;word-wrap:break-word;max-width:60%;color:#fff;text-align:left}.ngx-util-chat-right .message{color:#fff;margin:0;opacity:1;font-size:.875rem}.img-message{height:10rem;width:auto}.ngx-util-chat-right .hour{color:rgba(255,255,255,.5);opacity:1;font-size:.8125rem}.ngx-util-chat-left .message{color:#324148;margin:0;opacity:1;font-size:.875rem}.ngx-util-chat-left .hour{color:rgba(50,65,72,.4);opacity:1;font-size:.8125rem}.ngx-util-msg-read{color:#fff}"]
            }] }
];
/** @nocollapse */
ChatDetailMessageComponent.ctorParameters = () => [];
ChatDetailMessageComponent.propDecorators = {
    messages: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente que trabaja sobre ngx-perfect-scrollbar
 */
class PerfectScrollComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Variables de configuarion
         */
        this.config = {};
    }
    /**
     * Despues de verificar que carge el viewchild mueve el scroll a la parte deseada
     * @return {?}
     */
    ngAfterViewChecked() {
        if (this.position !== undefined && this.elementName === undefined) {
            this.calculatePosition(this.position);
        }
        else if (this.elementName !== undefined) {
            this.scrollToElement();
        }
    }
    /**
     * Segun las coordenadas indica al scroll que accion realizar
     * @param {?} position Array con el eje x y
     * @return {?}
     */
    calculatePosition(position) {
        if (position[0] === EScrollPosition.start) {
            this.scrollToLeft();
        }
        if (position[0] === EScrollPosition.end) {
            this.scrollToRight();
        }
        if (position[1] === EScrollPosition.start) {
            this.scrollToTop();
        }
        if (position[1] === EScrollPosition.end) {
            this.scrollToBottom();
        }
        if (position[0] > 0 && position[1] > 0) {
            this.scrollToXY(position[0], position[1]);
        }
    }
    /**
     * Mover el scroll a un posicion
     * @param {?} x Eje x
     * @param {?} y Eje y
     * @return {?}
     */
    scrollToXY(x, y) {
        if (this.componentRef !== undefined && this.componentRef.directiveRef) {
            this.componentRef.directiveRef.scrollTo(x, y, 500);
        }
    }
    /**
     * mover el scroll a la parte superio
     * @return {?}
     */
    scrollToTop() {
        if (this.componentRef !== undefined && this.componentRef.directiveRef) {
            this.componentRef.directiveRef.scrollToTop();
        }
    }
    /**
     * mover el scroll a la izquierda
     * @return {?}
     */
    scrollToLeft() {
        if (this.componentRef !== undefined && this.componentRef.directiveRef) {
            this.componentRef.directiveRef.scrollToLeft();
        }
    }
    /**
     * Mover el scroll a  la derecha
     * @return {?}
     */
    scrollToRight() {
        if (this.componentRef !== undefined && this.componentRef.directiveRef) {
            this.componentRef.directiveRef.scrollToRight();
        }
    }
    /**
     * mover el scroll al final
     * @return {?}
     */
    scrollToBottom() {
        if (this.componentRef !== undefined && this.componentRef.directiveRef) {
            this.componentRef.directiveRef.scrollToBottom();
        }
    }
    /**
     * mover el scroll al elemento
     * @return {?}
     */
    scrollToElement() {
        if (this.componentRef !== undefined && this.componentRef.directiveRef) {
            this.componentRef.directiveRef.scrollToElement('#' + this.elementName);
        }
    }
    /**
     * Al movernos sobre el div
     * @param {?} event scroll
     * @return {?}
     */
    onScrollEvent(event) {
        event.preventDefault();
        event.stopPropagation();
    }
}
PerfectScrollComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-perfect-scroll',
                template: "<perfect-scrollbar class=\"scroll-container window__list\" fxFlex=\"auto\" [config]=\"config\" [scrollIndicators]=\"true\"\n  (psXReachEnd)=\"onScrollEvent($event)\" (psYReachEnd)=\"onScrollEvent($event)\" (psXReachStart)=\"onScrollEvent($event)\"\n  (psYReachStart)=\"onScrollEvent($event)\">\n  <div class=\"scrollable-content\">\n    <ng-content></ng-content>\n  </div>\n</perfect-scrollbar>",
                styles: [".scroll-container{position:relative}.scrollable-content{padding:16px;margin:0}"]
            }] }
];
/** @nocollapse */
PerfectScrollComponent.ctorParameters = () => [];
PerfectScrollComponent.propDecorators = {
    componentRef: [{ type: ViewChild, args: [PerfectScrollbarComponent, { static: false },] }],
    position: [{ type: Input }],
    elementName: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Modulo que contiene un scroll perfecto para usar en nuestros div estilizado
 * @type {?}
 */
const DEFAULT_PERFECT_SCROLLBAR_CONFIG = {
    wheelPropagation: true
};
const ɵ0 = DEFAULT_PERFECT_SCROLLBAR_CONFIG;
class NgxUtilitarioPerfectScrollModule {
}
NgxUtilitarioPerfectScrollModule.decorators = [
    { type: NgModule, args: [{
                declarations: [PerfectScrollComponent],
                imports: [
                    CommonModule,
                    PerfectScrollbarModule
                ],
                exports: [
                    PerfectScrollComponent,
                    PerfectScrollbarModule
                ],
                providers: [
                    {
                        provide: PERFECT_SCROLLBAR_CONFIG,
                        useValue: ɵ0
                    }
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Componente en el cual podremos visualizar una imagen
 */
class ChatDetailPreviewComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Variable en la cual se guardara el titulo de la vista previa
         */
        this.title = 'Vista Previa';
        /**
         * Evento indicando que cierre la ventana
         */
        this.close = new EventEmitter();
        /**
         * arreglo en el cual guardaremos las imagenes seleccionadas
         */
        this.imgUrls = [];
    }
    /**
     * 1.- si cambian los archivos mostrar el primer archivo
     * @param {?} changes Si cambia files
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.files) {
            this.finalFiles = changes.files.currentValue;
            this.previewFiles();
            this.previewFile();
        }
    }
    /**
     * Metodo el cual mostrara la imagen seleccionada o la primera por defecto
     * @param {?=} imgUrl
     * @return {?}
     */
    previewFile(imgUrl) {
        if (imgUrl !== undefined) {
            this.imgUrl = imgUrl;
            return;
        }
        if (this.finalFiles) {
            if (this.finalFiles.length <= 0) {
                return;
            }
            /** @type {?} */
            const mimeType = this.finalFiles[0].type;
            if (mimeType.match(/image\/*/) == null) {
                return;
            }
            /** @type {?} */
            const reader = new FileReader();
            // this.imagePath = this.finalFiles;
            reader.readAsDataURL(this.finalFiles[0]);
            reader.onload = (/**
             * @return {?}
             */
            () => {
                this.imgUrl = reader.result;
            });
        }
    }
    /**
     * Metodo que permitira visualizar todas las imagenes
     * @return {?}
     */
    previewFiles() {
        if (this.finalFiles) {
            if (this.finalFiles.length === 0) {
                return;
            }
            /** @type {?} */
            const mimeType = this.finalFiles[0].type;
            if (mimeType.match(/image\/*/) == null) {
                return;
            }
            this.imgUrls = [];
            Array.from(this.finalFiles).forEach((/**
             * @param {?} file
             * @return {?}
             */
            file => {
                /** @type {?} */
                const readerGallery = new FileReader();
                readerGallery.onload = (/**
                 * @param {?} e
                 * @return {?}
                 */
                (e) => {
                    this.imgUrls.push(e.target.result);
                });
                readerGallery.readAsDataURL(file);
            }));
        }
    }
    /**
     * Devulve la longitud de archivos en finalFiles o cero en caso sea undefined
     * @return {?}
     */
    filesCount() {
        if (this.finalFiles === undefined) {
            return 0;
        }
        return this.finalFiles.length;
    }
    /**
     * Emite un evento para cerrar vista
     * @return {?}
     */
    closePreview() {
        this.close.emit(true);
    }
    /**
     * Agregaremos mas imagenes a las imagenes mostradas actualmente
     * @param {?} images
     * @return {?}
     */
    addImage(images) {
    }
}
ChatDetailPreviewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-chat-detail-preview',
                template: "<!--Titulo del componente-->\n<div class=\"w-100 ngx-util-preview-title\">\n  <em class=\"fa fa-times ngx-util-em-action\" (click)=\"closePreview()\"></em> {{title}}\n</div>\n<!--div donde mostrara la imagen  seleccionada e insercion del texto-->\n<div class=\"ngx-util-preview-body\">\n  <img src=\"{{imgUrl}}\" alt=\"img preview\" height=\"200\" *ngIf=\"imgUrl\">\n</div>\n<!--todos los archivos seleccionados y la posibilidad de a\u00F1adir mas archivos-->\n<div class=\"ngx-util-preview-files\">\n  <div class=\"row no-margin\">\n    <ngx-utilitario-perfect-scroll class=\"col-10\">\n      <div class=\"ngx-util-preview-all-files\">\n        <div *ngFor=\"let index of filesCount() | numberToArray\" class=\"ngx-util-preview-files-item\">\n          <img src=\"{{imgUrls[index]}}\" alt=\"img preview\" height=\"100\" (click)=\"previewFile(imgUrls[index])\">\n          <!-- <div style=\"height: 100px; width: 100px; background:red; border: 1px solid black\"></div> -->\n        </div>\n      </div>\n    </ngx-utilitario-perfect-scroll>\n    <input class=\"ngx-util-input-file\" type=\"file\" accept=\"image/*\" #file (change)=\"addImage($event)\" multiple>\n    <div class=\"ngx-util-preview-files-add\" (click)=\"file.click()\"> \n      <em class=\"fa fa-plus ngx-util-preview-files-add-icon\"></em> Agregar Imagenes\n    </div>\n  </div>\n</div>",
                styles: [".ngx-util-preview-title{background:#e7b723;color:#fff;padding:.9375rem 1.25rem;font-size:1rem}.ngx-util-em-action{padding:.625rem .875rem;transition:.2s ease-in-out;-webkit-transform-style:preserve-3d;transform-style:preserve-3d}.ngx-util-em-action:hover{background:rgba(255,255,255,.2);outline:0!important;text-decoration:none;border-radius:50%}.ngx-util-preview-body{text-align:center;padding:18px 0}.ngx-util-preview-files{height:6.875rem;padding:10px 5px;background:#dddde0}.ngx-util-preview-all-files{display:flex}.ngx-util-preview-files-item{float:left;flex:0 0 16.666667%;max-width:16.666667%;text-align:center;margin:0 .3125rem}.ngx-util-preview-files-item img{flex:0 0 90%;max-width:90%;height:-webkit-fill-available}.ngx-util-preview-files-add{flex:0 0 14%;max-width:14%;font-size:14px;color:#e7b723;text-align:center;padding:.5rem 3%!important;background:#fff;margin-left:.625rem;cursor:pointer}.ngx-util-preview-files-add-icon{display:block;font-weight:900;font-size:xx-large}"]
            }] }
];
/** @nocollapse */
ChatDetailPreviewComponent.ctorParameters = () => [];
ChatDetailPreviewComponent.propDecorators = {
    title: [{ type: Input }],
    files: [{ type: Input }],
    close: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Modulo Chat el cual contiene las partes necesarias para el correcto funcinamiento de un chat
 */
class NgxUtilitarioChatModule {
}
NgxUtilitarioChatModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    ChatComponent,
                    ChatSearchComponent,
                    ChatListComponent,
                    ChatListDetailComponent,
                    ChatDetailComponent,
                    ChatDetailAddComponent,
                    ChatDetailMessageComponent,
                    ChatDetailPreviewComponent,
                ],
                imports: [
                    CommonModule,
                    ReactiveFormsModule,
                    NgxUtilitarioFormstModule,
                    NgxUtilitarioPerfectScrollModule,
                    NgxUtilitarioPipesModule,
                    MatIconModule
                ],
                exports: [
                    ChatComponent,
                    ChatSearchComponent,
                    ChatListComponent,
                    ChatListDetailComponent,
                    ChatDetailComponent,
                    ChatDetailAddComponent,
                    ChatDetailMessageComponent,
                    ChatDetailPreviewComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Mustra un menu dot
 */
class MenuDotComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Opciones de un menu
         */
        this.menu1 = {
            icon: 'block',
            nombre: 'bloqueo',
            text: 'Ver Chats Bloqueados'
        };
        /**
         * Opciones de un menu
         */
        this.menu2 = {
            icon: 'block',
            nombre: 'bloqueo',
            text: 'block 2'
        };
        /**
         * menu a mostrar
         */
        this.menus = [this.menu1, this.menu2];
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * Al hacer click en un elemento retornara el nombre del menu que realizo click
     * @param {?} item
     * @return {?}
     */
    menuClick(item) {
        console.log(item);
    }
}
MenuDotComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-menu-dot',
                template: "<button mat-icon-button [matMenuTriggerFor]=\"menuDot\">\n  <mat-icon>more_vert</mat-icon>\n</button>\n<mat-menu #menuDot=\"matMenu\">\n  <button mat-menu-item *ngFor=\"let item of menus\" (click)=\"menuClick(item)\" >\n    <mat-icon>{{item.icon}}</mat-icon>\n    <span>{{item.texto}}</span>\n  </button>\n</mat-menu>"
            }] }
];
/** @nocollapse */
MenuDotComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxUtilitarioMenuModule {
}
NgxUtilitarioMenuModule.decorators = [
    { type: NgModule, args: [{
                declarations: [MenuDotComponent],
                imports: [
                    MatMenuModule,
                    MatIconModule,
                    CommonModule
                ],
                exports: [
                    MenuDotComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Card con titulo, subtitulo e icono
 */
class CardsComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Icono a mostrar en el card
         */
        this.icono = 'fa fa-user';
        /**
         * Clase a aplicar al texto
         */
        this.classTexto = 'w-80 float-left';
        /**
         * Enviar el tamaño de columnas y el tamaño del icono
         */
        this.classIcono = 'w-20 fontSize2-5';
        /**
         * Color del icono a mostrar
         */
        this.color = '#000';
        /**
         * Enviar accion de click en el card
         */
        this.click = new EventEmitter();
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * Envia un evento si hace click en el card
     * @param {?} $event Caracteristicas del evento click en el card
     * @return {?}
     */
    clickCard($event) {
        this.click.emit($event);
    }
}
CardsComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-cards',
                template: "<div class=\"cards\" (click)=\"clickCard($event)\">\r\n    <div [ngClass]=\"classTexto\">\r\n        <h2 class=\"cardsTitulo\">{{titulo}}</h2>\r\n        <h3 class=\"cardsSubtitulo\">{{subtitulo}}</h3>\r\n        <h3 class=\"cardsContenido\"><ng-content></ng-content></h3>\r\n    </div>\r\n\r\n    <div [ngClass]=\"classIcono\">\r\n        <em class=\"{{icono}} float-right cardIcono\" [style.color]=\"color\"></em>\r\n    </div>\r\n</div>",
                styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left}.cards:hover{background-color:rgba(0,0,0,.05)}.cardsTitulo{font-size:.75rem;font-weight:700;text-transform:uppercase;color:#595959;padding:1rem 0 0 1.2rem;margin:0}.cardsSubtitulo{color:#b0b0b0;font-size:1.5rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardIcono{padding:1rem .5rem .5rem 0}.classIcono{display:table-cell;width:auto}.fontSize2-5{font-size:2.5rem;padding-right:0}"]
            }] }
];
/** @nocollapse */
CardsComponent.ctorParameters = () => [];
CardsComponent.propDecorators = {
    titulo: [{ type: Input }],
    subtitulo: [{ type: Input }],
    icono: [{ type: Input }],
    classTexto: [{ type: Input }],
    classIcono: [{ type: Input }],
    color: [{ type: Input }],
    click: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Card con titulo, descripcion, etiqueta, icono e imagen
 */
class CardsImgTextComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Descripciòn a mostrar en el card
         */
        this.descripcion = 'afdasdf';
        /**
         * Etiqueta a mostrar en el card
         */
        this.etiqueta = 'etiqueta';
        /**
         * Imagen a mostrar en el card
         */
        this.imagen = './assets/test.jpg';
        /**
         * recibe el icono a usar
         */
        this.icono = 'fa fa-user';
        /**
         * Enviar el tamaño de columnas y el tamaño del icono
         */
        this.classTexto = 'w-80 float-left';
        /**
         * Clase para asignar al icono
         */
        this.classIcono = 'col-1 align-middle cardIcono';
        /**
         * Color del icono
         */
        this.color = '#000';
        /**
         * Altura del icono
         */
        this.height = '6.5rem';
        /**
         * Acccion click en el card
         */
        this.click = new EventEmitter();
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * Envia un evento si hace click en el card
     * @param {?} $event Caracteristicas del evento click en el card
     * @return {?}
     */
    clickCard($event) {
        this.click.emit($event);
    }
}
CardsImgTextComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-cards-img-text',
                template: "<div class=\"row cards row-no-padding\" [style.color]=\"color\" (click)=\"clickCard($event)\">\r\n  <div class=\"col-2 float-left\">\r\n      <img class=\"cardsImagen\" src={{imagen}} alt=\"imagen de card cambiar a dinamico\" [style.height]=\"height\" />\r\n  </div>\r\n  <div class=\"col-9\">\r\n      <div [ngClass]=\"classTexto\">\r\n          <h2 class=\"cardsTitulo\" [style.color]=\"color\">{{titulo}}</h2>\r\n          <h3 class=\"cardsDescripcion\">{{descripcion}}</h3>\r\n          <h3 class=\"cardsEtiqueta\" [style.background]=\"color\">{{etiqueta}}</h3>\r\n          <h3 class=\"cardsContenido\"><ng-content></ng-content></h3>\r\n      </div>\r\n  </div>\r\n  <div [ngClass]=\"classIcono\">\r\n      <em class=\"{{icono}} float-right cardIcono\"></em>\r\n  </div>\r\n</div>",
                styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left;display:table!important;-moz-box-shadow:0 1px 2px rgba(0,0,0,.2);-webkit-box-shadow:0 1px 2px rgba(0,0,0,.2);transition:.5s;margin:10px 0}.cards:hover{background-color:rgba(0,0,0,.05);-webkit-transform:translateX(5px);transform:translateX(5px)}.cardsImagen{width:100%;-o-object-fit:fill;object-fit:fill}.cardsTitulo{font-size:1.25rem;font-weight:700;color:#595959;padding:.35rem 0 0 1.2rem;margin:0}.cardsDescripcion{color:#b0b0b0;font-size:1rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardsEtiqueta{display:inline-block;margin:0 0 0 1.2rem;padding:.25rem .5rem;color:#fff;font-size:.6rem;text-transform:capitalize;border-radius:.25rem}.classIcono{vertical-align:middle}.cardIcono{padding:.7rem .5rem .5rem 0;display:table-cell;width:auto}.fontSize40{font-size:2.5rem;padding-right:0}"]
            }] }
];
/** @nocollapse */
CardsImgTextComponent.ctorParameters = () => [];
CardsImgTextComponent.propDecorators = {
    titulo: [{ type: Input }],
    descripcion: [{ type: Input }],
    etiqueta: [{ type: Input }],
    imagen: [{ type: Input }],
    icono: [{ type: Input }],
    classTexto: [{ type: Input }],
    classIcono: [{ type: Input }],
    color: [{ type: Input }],
    height: [{ type: Input }],
    click: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Card con titulo, descripcion, etiqueta, icono y contenido
 */
class CardsImgTextNdivComponent {
    /**
     * @ignore
     */
    constructor() {
        /**
         * Descripciòn a mostrar en el card
         */
        this.descripcion = 'afdasdf';
        /**
         * Etiqueta a mostrar en el card
         */
        this.etiqueta = 'etiqueta';
        /**
         * Imagen a mostrar en el card
         */
        this.imagen = './assets/test.jpg';
        /**
         * Enviar el tamaño de columnas y el tamaño del icono
         */
        this.classTexto = 'float-left';
        /**
         * Color del icono
         */
        this.color = '#000';
        /**
         * Altura del icono
         */
        this.height = '6.5rem';
        /**
         * Contenido a mostrar dinamicamente
         */
        this.contenido = [];
        /**
         * Acccion click en el card
         */
        this.click = new EventEmitter();
    }
    /**
     * @ignore
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * Envia un evento si hace click en el card
     * @param {?} $event Caracteristicas del evento click en el card
     * @return {?}
     */
    clickCard($event) {
        this.click.emit($event);
    }
}
CardsImgTextNdivComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-utilitario-cards-img-text-ndiv',
                template: "<div class=\"cards row row-no-padding\" [style.color]=\"color\" (click)=\"clickCard($event)\">\r\n  <div class=\"col-2 float-left\">\r\n      <img class=\"cardsImagen\" src={{imagen}} alt=\"imagen de card cambiar a dinamico\" [style.height]=\"height\"/>\r\n  </div>\r\n  <div class=\"col-{{10 - contenido.length }} float-left\">\r\n      <div [ngClass]=\"classTexto\">\r\n          <h2 class=\"cardsTitulo\" [style.color]=\"color\">{{titulo}}</h2>\r\n          <h3 class=\"cardsDescripcion\">{{descripcion}}</h3>\r\n          <h3 class=\"cardsEtiqueta\" [style.background]=\"color\">{{etiqueta}}</h3>\r\n          <h3 class=\"cardsContenido\"><ng-content></ng-content></h3>\r\n      </div>\r\n  </div>\r\n  <div *ngFor=\"let item of contenido\" class=\"col-1 float-left center-middle\" [style.line-height]=\"height\">\r\n      <ng-content *ngIf=\"item==='content'\"></ng-content>\r\n      <span *ngIf=\"item!=='content'\">{{item}}</span>\r\n  </div>\r\n</div>",
                styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left;display:table!important;-moz-box-shadow:0 1px 2px rgba(0,0,0,.2);-webkit-box-shadow:0 1px 2px rgba(0,0,0,.2);transition:.5s}.cards:hover{background-color:rgba(0,0,0,.05);-webkit-transform:translateX(5px);transform:translateX(5px)}.cardsImagen{width:100%;-o-object-fit:fill;object-fit:fill;padding-left:1.2rem}.cardsTitulo{font-size:1.25rem;font-weight:700;color:#595959;padding:.35rem 0 0 1.2rem;margin:0}.cardsDescripcion{color:#b0b0b0;font-size:1rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardsEtiqueta{display:inline-block;margin:0 0 0 1.2rem;padding:.25rem .5rem;color:#fff;font-size:.6rem;text-transform:capitalize;border-radius:.25rem}.classIcono{vertical-align:middle}.cardIcono{padding:.7rem .5rem .5rem 0;display:table-cell;width:auto}.fontSize40{font-size:2.5rem;padding-right:0}"]
            }] }
];
/** @nocollapse */
CardsImgTextNdivComponent.ctorParameters = () => [];
CardsImgTextNdivComponent.propDecorators = {
    titulo: [{ type: Input }],
    descripcion: [{ type: Input }],
    etiqueta: [{ type: Input }],
    imagen: [{ type: Input }],
    classTexto: [{ type: Input }],
    color: [{ type: Input }],
    height: [{ type: Input }],
    contenido: [{ type: Input }],
    click: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Modulo el cual contiene componentes de cards
 */
class NgxUtilitarioCardsModule {
}
NgxUtilitarioCardsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [CardsComponent, CardsImgTextComponent, CardsImgTextNdivComponent],
                imports: [
                    CommonModule
                ],
                exports: [
                    CardsComponent, CardsImgTextComponent, CardsImgTextNdivComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxUtilitarioRcltModule {
}
NgxUtilitarioRcltModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                imports: [
                    CommonModule,
                    ReactiveFormsModule,
                    BrowserModule,
                    BrowserAnimationsModule,
                    MatButtonModule,
                    AngularFontAwesomeModule,
                    NgxUtilitarioFormstModule,
                    NgxUtilitarioChatModule,
                    NgxUtilitarioMenuModule,
                    NgxUtilitarioCardsModule,
                    NgxUtilitarioDynamicModule,
                    NgxUtilitarioIconsModule,
                    NgxUtilitarioModalModule,
                    NgxUtilitarioPerfectScrollModule,
                    NgxUtilitarioPipesModule
                ],
                exports: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const EChatState = {
    /**
     * Si estoy conectado al chat
     */
    online: 1,
    /**
     * Si estoy desconectado al chat
     */
    offline: 0,
};
EChatState[EChatState.online] = 'online';
EChatState[EChatState.offline] = 'offline';

export { DynamicComponentService, EChatLock, EChatState, EMessageState, EMessageType, NgxUtilitarioCardsModule, NgxUtilitarioChatModule, NgxUtilitarioDynamicModule, NgxUtilitarioFormstModule, NgxUtilitarioIconsModule, NgxUtilitarioMenuModule, NgxUtilitarioModalModule, NgxUtilitarioPerfectScrollModule, NgxUtilitarioPipesModule, NgxUtilitarioRcltModule, InputComponent as ɵa, InputSearchComponent as ɵb, ChatComponent as ɵc, ChatSearchComponent as ɵd, ChatListComponent as ɵe, ChatListDetailComponent as ɵf, ChatDetailComponent as ɵg, ChatDetailAddComponent as ɵh, ChatDetailMessageComponent as ɵi, ChatDetailPreviewComponent as ɵj, PerfectScrollComponent as ɵk, HighlightPipe as ɵl, NumberToArrayPipe as ɵm, MenuDotComponent as ɵn, CardsComponent as ɵo, CardsImgTextComponent as ɵp, CardsImgTextNdivComponent as ɵq, RepeatIconComponent as ɵr, ModalComponent as ɵs, ModalService as ɵt };
//# sourceMappingURL=ngx-utilitario-rclt.js.map
