import { OnInit, EventEmitter } from '@angular/core';
import { IChatListDetail } from '../../dto/ichat-list-detail';
/**
 * Componente que muestra todas las conversaciones que tienes
 */
export declare class ChatListComponent implements OnInit {
    /**
     * Lista de chats que tienes
     */
    list: IChatListDetail[];
    /**
     * Si se desea resaltar un texto en la lista de un chat
     */
    search: string;
    /**
     * Si hace click en una conversacion retornara un evento
     */
    clickList: EventEmitter<any>;
    /**
     * @ignore
     */
    constructor();
    /**
     * @ignore
     */
    ngOnInit(): void;
    /**
     * retorna el chat que realiza click
     * @param detail las propiedades del chat
     */
    click(detail: IChatListDetail): void;
}
